#todo: make it a definition, and make it update the global dictionary
#make a separate initialization thing. - run it off a thingy.
#make a seperate game thing - make it run
#This amazing code pulls the hydra data from the hydra into blender.
#credits Moredread & Wraaah & Paul the Great & Dr. Wonko
# - you probably won't change this file - just tweak menu.py / setup.py / game.py

import bge
import PySixense
import mathutils
from setup import hydraSetup #imports data you can set outside this file.
#import pause

#used later on - sets the tap margin for sticks 
tapMargin = hydraSetup.tapMargin

def initialize(cont):
	#Initialize hydra and activate update part
	hydra_init = PySixense.Init()
	if  hydra_init == PySixense.Constants.Success:
		print("Initializing Sixense SDK OK")
		own = cont.owner
		own["use_hydra"] = True
	else:
		print("Error initializing Sixense SDK")
		


def hydraUpdate():
	hydra_init = PySixense.Init()
	
	statusL, dataL = PySixense.GetNewestData(0)
	statusR, dataR = PySixense.GetNewestData(1)

	if not PySixense.IsControllerEnabled(0) or not PySixense.IsControllerEnabled(1):
		#turns off the hydra update thingy
		
		#pauses the game
		hydraPause()
	else:	
		#makes a dictionary called hydraData - we're currently using this for checking previous hydra data
		#this way, we can signal taps of the buttons, or if we add it, trigger clicks and stuff
		
		hydraData = {}
		
		#gets data from previous tic, so we can use it to check for taps and stuff.
		dataPrevious = bge.logic.globalDict.get("hydraData", False)
			
		
		
		#########################
		#Joysticks, range -1 to 1
		#########################
		
		hydraData["joyXL"] = dataL.joystick_x
		hydraData["joyYL"] = dataL.joystick_y
		
		hydraData["joyXR"] = dataR.joystick_x
		hydraData["joyYR"] = dataR.joystick_y
		
				
		#########################
		#Triggers, pressure sensitive, range from 0 to 1
		#########################
		
		hydraData["trigL"] = dataL.trigger
		hydraData["trigR"] = dataR.trigger
		
		
		###################
		#buttons... 
		###################
		
		#the .buttons gives you a combined total of all the buttons values, 
		#1,8,16,32,64,128 & 256, so the following code checks for and reports all of them
		
		#assign buttons to easy to understand and remember variables.
		#we're using a bitwise & operator - if it's positive it equals it's value, if not, it equals 0.
		hydraData["bAnyL"] = dataL.buttons
		hydraData["bStickL"] = dataL.buttons & 256
		hydraData["bBumperL"] = dataL.buttons & 128
		hydraData["b2L"] = dataL.buttons & 64
		hydraData["b1L"] = dataL.buttons & 32
		hydraData["b4L"] = dataL.buttons & 16
		hydraData["b3L"] = dataL.buttons & 8
		hydraData["bStartL"] = dataL.buttons & 1
			
		hydraData["bAnyR"] = dataR.buttons
		hydraData["bStickR"] = dataR.buttons & 256
		hydraData["bBumperR"] = dataR.buttons & 128
		hydraData["b2R"] = dataR.buttons & 64
		hydraData["b1R"] = dataR.buttons & 32
		hydraData["b4R"] = dataR.buttons & 16
		hydraData["b3R"] = dataR.buttons & 8
		hydraData["bStartR"] = dataR.buttons & 1
		
		#print ("dataPrevious",dataPrevious)
		#if previous input was 0, then there are errors, so we need this line first.
		if dataPrevious:
			
			#if a button was previously off and now is on, it's tapped status is on =)
			# 0&0 = 0  1&0 = 0 1&1 = 0, 0&1 = 1
			
			#button taps!
			
			hydraData["bAnyTapL"] = not dataPrevious["buttonsL"] and dataL.buttons
			hydraData["bStickTapL"] = not dataPrevious["buttonsL"] & 256 and dataL.buttons & 256
			hydraData["bBumperTapL"] = not dataPrevious["buttonsL"] & 128 and dataL.buttons & 128
			hydraData["b2TapL"] = not dataPrevious["buttonsL"] & 64 and dataL.buttons & 64
			hydraData["b1TapL"] = not dataPrevious["buttonsL"] & 32 and dataL.buttons & 32
			hydraData["b3TapL"] = not dataPrevious["buttonsL"] & 16 and dataL.buttons & 16
			hydraData["b4TapL"] = not dataPrevious["buttonsL"] & 8 and dataL.buttons & 8
			hydraData["bStartTapL"] = not dataPrevious["buttonsL"] & 1 and dataL.buttons & 1
			
			
			hydraData["bAnyTapR"] = not dataPrevious["buttonsR"] and dataR.buttons
			hydraData["bStickTapR"] = not dataPrevious["buttonsR"] & 256 and dataR.buttons & 256
			hydraData["bBumperTapR"] = not dataPrevious["buttonsR"] & 128 and dataR.buttons & 128
			hydraData["b2TapR"] = not dataPrevious["buttonsR"] & 64 and dataR.buttons & 64
			hydraData["b1TapR"] = not dataPrevious["buttonsR"] & 32 and dataR.buttons & 32
			hydraData["b3TapR"] = not dataPrevious["buttonsR"] & 16 and dataR.buttons & 16
			hydraData["b4TapR"] = not dataPrevious["buttonsR"] & 8 and dataR.buttons & 8
			hydraData["bStartTapR"] = not dataPrevious["buttonsR"] & 1 and dataR.buttons & 1
			
			#trigger taps!
			hydraData["trigTapL"] = not dataPrevious["trigL"] and dataL.trigger
			hydraData["trigTapR"] = not dataPrevious["trigR"] and dataR.trigger
			
			#joystick taps! 
			#north/up - south/down - east/right - west/left
			hydraData["joyTapNorthL"] = hydraData["joyYL"] > tapMargin and dataPrevious["joyYL"] < tapMargin
			hydraData["joyTapSouthL"] = hydraData["joyYL"] < -tapMargin and dataPrevious["joyYL"] > -tapMargin
			hydraData["joyTapEastL"] = hydraData["joyXL"] > tapMargin and dataPrevious["joyXL"] < tapMargin
			hydraData["joyTapWestL"] = hydraData["joyXL"] < -tapMargin and dataPrevious["joyXL"] > -tapMargin
			
			hydraData["joyTapNorthR"] = hydraData["joyYR"] > tapMargin and dataPrevious["joyYR"] < tapMargin
			hydraData["joyTapSouthR"] = hydraData["joyYR"] < -tapMargin and dataPrevious["joyYR"] > -tapMargin
			hydraData["joyTapEastR"] = hydraData["joyXR"] > tapMargin and dataPrevious["joyXR"] < tapMargin
			hydraData["joyTapWestR"] = hydraData["joyXR"] < -tapMargin and dataPrevious["joyXR"] > -tapMargin

		#if we haven't recieved any data, from a previous loop, we just leave 'em all blank.
		#this only executes once ever.
		else:
			hydraData["bStickTapL"] = 0
			hydraData["bBumperTapL"] = 0
			hydraData["b2TapL"] = 0
			hydraData["b1TapL"] = 0
			hydraData["b3TapL"] = 0
			hydraData["b4TapL"] = 0
			hydraData["bStartTapL"] = 0
			hydraData["bAnyTapL"] = 0
						
			hydraData["bStickTapR"] = 0
			hydraData["bBumperTapR"] = 0
			hydraData["b2TapR"] = 0
			hydraData["b1TapR"] = 0
			hydraData["b3TapR"] = 0
			hydraData["b4TapR"] = 0
			hydraData["bStartTapR"] = 0
			hydraData["bAnyTapR"] = 0
		
			#triggerz
			hydraData["trigTapL"] = 0
			hydraData["trigTapR"] = 0
			
			#joysticks
			hydraData["joyTapNorthL"] = 0
			hydraData["joyTapSouthL"] = 0
			hydraData["joyTapEastL"] = 0
			hydraData["joyTapWestL"] = 0
			
			hydraData["joyTapNorthR"] = 0
			hydraData["joyTapSouthR"] = 0
			hydraData["joyTapEastR"] = 0
			hydraData["joyTapWestR"] = 0
		
		
			
		#stores this tic's values in a dictionary in hydraData
		#we'll add it to the global dictionary a few lines down
		#and we'll be able to compare it to our current data to check for changes
		hydraData["buttonsR"] = dataR.buttons
		hydraData["buttonsL"] = dataL.buttons

		

		
		
		##########################
		#Position - x, y, z, 
		##########################
		
		### 1st: kick out raw position data!
		
		#we need to rearrage the data from the hydra - props to Moredread for finding this out =)
		hydraData["locRawL"] = locRawL = mathutils.Vector([dataL.pos[0], -dataL.pos[2], dataL.pos[1]])
		hydraData["locRawR"] = locRawR = mathutils.Vector([dataR.pos[0], -dataR.pos[2], dataR.pos[1]])
		
		
		### 2nd: load calibration data ###
		#you can change the backup values to avoid calibration.
		
		#since your hydra's origin is at it's base, we need to offset that so players can be in their own play space
		#the offset values are combined with the hydra location data to define new origins!
		offsetL = hydraSetup.offsetL
		offsetR = hydraSetup.offsetR
		#print("offsetL", offsetL)

		
		#the game scale value keeps the hydra controllers in box shaped zone in the game that's the right size.
		#or in other words, if your clip default is 2000 and your game scale is 200, you'll be able to move you
		#hydras 1000mm to move 10 units in game - you'll probably need to adjust these values unless I make somethin' else up.
		gameEdgeL = hydraSetup.gameEdgeL 
		gameEdgeR = hydraSetup.gameEdgeR
		
		#print("gameScale",gameScaleL)

		
		### 5th. Apply all data! ###
		
		#sets the hydra location data to a vector in blender's XYZ, 
		#offsets by the calibration data, 
		#and scales it to fit the hydraZone in the game.
		locL = (mathutils.Vector(locRawL)) / (gameEdgeL / hydraSetup.hydraZone)
		locR = (mathutils.Vector(locRawR)) / (gameEdgeR / hydraSetup.hydraZone)
		
		#stick in the dictionary
		hydraData["locL"] = locL - offsetL
		hydraData["locR"] = locR - offsetR
		
		
		
		#print ("righ", locR)
		#print ("left", locL)
		
		#need to know how to offset your hydras? uncomment these lines to find out, and turn on the blender console
		#print ("raaaaaw", locRawL)
		#print ("offfset", offsetL)
		
		
		##################
		#Rotation
		##################
		hydraData["rotL"] = mathutils.Quaternion([dataL.rot_quat[3], dataL.rot_quat[0], -dataL.rot_quat[2], dataL.rot_quat[1]])
		hydraData["rotR"] = mathutils.Quaternion([dataR.rot_quat[3], dataR.rot_quat[0], -dataR.rot_quat[2], dataR.rot_quat[1]])
				
		#sends all the data we set to compare over two frames into the dictionary to be evaluated next tic!
		bge.logic.globalDict["hydraData"] = hydraData

def hydraPause():
	#this is called from the hydra.py hy class if the controller isn't connected
	print("hydra.py.hydrapause: Active, because your hydra is disconnected!")

	#get controller
	cont = bge.logic.getCurrentController()
		
	#get the actuator on that controller
	sceneSuspender = cont.actuators["scene"]

	#get scene
	sce = bge.logic.getCurrentScene()   
	
	#Set the scene we're going to suspend as the current scene
	sceneSuspender.scene = sce.name
	
	#set mode for actuator to "suspend"
	sceneSuspender.mode = 7
	
	#store that in the global dictionary
	bge.logic.globalDict["pausedScene"] = sce.name

		#actiave the suspend controller to lock down that scene.
	cont.activate(sceneSuspender)

		#add the hydraDisconnected overlay scene. (always going to be named hydraDisconnected)
	addOverlay = cont.actuators["addOverlay"]
	cont.activate(addOverlay)
		
	#let people know their hydra is disconnected with text on screen, and diagrams and stuff

def hydraResume():
	#if activity, unpause
	
	
	if PySixense.Init() == PySixense.Constants.Success:
		if PySixense.IsControllerEnabled(0) or PySixense.IsControllerEnabled(1):
			#hy = bge.logic.globalDict.get("hydraData", False)
			#if hy["bAnyL"] or hy["bAnyL"]:
			#assign buttons R and L to stuff
			#if any button pressed: resume!
			#remove the hydraDisconnected overlay scene - always called "hydraDisconnected" and entered in the actuator in the scene.

				#get controller
			cont = bge.logic.getCurrentController()
			
				#get the actuator on that controller
			sceneResumer = cont.actuators["resume"]
				
				#Set the current scene as the one we're going to resume
				#it's always going to be the current scene, because we removed the overlay scene before we found the current scene.

			pausedScene = bge.logic.globalDict["pausedScene"]
			
			print ("hydra.py.hydraResume: gratch, we're resuming to scene:", pausedScene)
			
			#needs to be connected to an object
			sceneResumer.scene = pausedScene
			cont.activate(sceneResumer)
				#resume the scene.

			removeOverlay = cont.actuators["removeOverlay"]
			print ("hydra.py.hydraResume: removing overlay from scene:",removeOverlay.scene)
			cont.activate(removeOverlay)
	
def hydraExit():
	
	#This lovely script shuts down the hydra pysense.pyd stuff.
	if PySixense.Init() == PySixense.Constants.Success:
		assert(PySixense.Exit() == PySixense.Constants.Success)
	print("quitting??")
	bge.logic.endGame()
	